Package: pakret
Title: Cite 'R' Packages on the Fly in 'R Markdown' and 'Quarto'
Version: 0.3.1
Authors@R: 
    person("Arnaud", "Gallou", , "arangacas@gmail.com", role = c("aut", "cre", "cph"),
           comment = c(ORCID = "0000-0002-1002-4247"))
Description: References and cites 'R' and 'R' packages on the fly in 'R
    Markdown' and 'Quarto'. 'pakret' provides a minimalist API that
    generates preformatted citations for 'R' and 'R' packages, and adds
    their references to a '.bib' file directly from within your document.
License: GPL (>= 3)
URL: https://arnaudgallou.github.io/pakret/,
        https://github.com/arnaudgallou/pakret
BugReports: https://github.com/arnaudgallou/pakret/issues
Depends: R (>= 3.6.0)
Imports: knitr (>= 1.51), readr (>= 1.0.0), rmarkdown
Suggests: callr (>= 3.7.5), pkgload, testthat (>= 3.0.0), usethis,
        withr (>= 2.5.0)
Config/Needs/website: arnaudgallou/cygne
Config/testthat/edition: 3
Encoding: UTF-8
RoxygenNote: 7.3.3
NeedsCompilation: no
Packaged: 2026-04-15 10:04:32 UTC; arnaud
Author: Arnaud Gallou [aut, cre, cph] (ORCID:
    <https://orcid.org/0000-0002-1002-4247>)
Maintainer: Arnaud Gallou <arangacas@gmail.com>
Repository: CRAN
Date/Publication: 2026-04-15 10:20:02 UTC
Built: R 4.6.0; ; 2026-04-26 20:21:10 UTC; unix

Package: pakret
Title: Cite 'R' Packages on the Fly in 'R Markdown' and 'Quarto'
Version: 0.3.1
Authors@R: 
    person("Arnaud", "Gallou", , "arangacas@gmail.com", role = c("aut", "cre", "cph"),
           comment = c(ORCID = "0000-0002-1002-4247"))
Description: References and cites 'R' and 'R' packages on the fly in 'R
    Markdown' and 'Quarto'. 'pakret' provides a minimalist API that
    generates preformatted citations for 'R' and 'R' packages, and adds
    their references to a '.bib' file directly from within your document.
License: GPL (>= 3)
URL: https://arnaudgallou.github.io/pakret/,
        https://github.com/arnaudgallou/pakret
BugReports: https://github.com/arnaudgallou/pakret/issues
Depends: R (>= 3.6.0)
Imports: knitr (>= 1.51), readr (>= 1.0.0), rmarkdown
Suggests: callr (>= 3.7.5), pkgload, testthat (>= 3.0.0), usethis,
        withr (>= 2.5.0)
Config/Needs/website: arnaudgallou/cygne
Config/testthat/edition: 3
Encoding: UTF-8
RoxygenNote: 7.3.3
NeedsCompilation: no
Packaged: 2026-04-15 10:04:32 UTC; arnaud
Author: Arnaud Gallou [aut, cre, cph] (ORCID:
    <https://orcid.org/0000-0002-1002-4247>)
Maintainer: Arnaud Gallou <arangacas@gmail.com>
Repository: CRAN
Date/Publication: 2026-04-15 10:20:02 UTC

<!-- README.md is generated from README.Rmd. Please edit that file -->

# pakret

<!-- badges: start -->

[![Lifecycle:
stable](https://img.shields.io/badge/lifecycle-stable-brightgreen.svg)](https://lifecycle.r-lib.org/articles/stages.html#stable)
[![CRAN
status](https://www.r-pkg.org/badges/version/pakret)](https://CRAN.R-project.org/package=pakret)
[![R-CMD-check](https://github.com/arnaudgallou/pakret/actions/workflows/R-CMD-check.yaml/badge.svg)](https://github.com/arnaudgallou/pakret/actions/workflows/R-CMD-check.yaml)
<!-- badges: end -->

## Overview

pakret is a minimalist R package citation tool to reference and cite R
and R packages on the fly in R Markdown and Quarto.

## Key features

- Allows independent, inline citations of a single package or a list of
  packages.
- Supports full customization of package citations.
- Can cite packages in tabular format.
- Appends new references to existing `.bib` files.
- Uses a single reference per package, prioritizing `manual` and `book`
  entries.

## Installation

Install pakret from CRAN with:

``` r
install.packages("pakret")
```

Alternatively, you can install the development version of pakret from
GitHub with:

``` r
# install.packages("pak")
pak::pak("arnaudgallou/pakret")
```

## Usage

Simply use `pkrt()` whenever you want to cite R or an R package in your
document:

    ---
    bibliography: references.bib
    ---

    ```{r}
    #| include: false
    library(pakret)
    ```

    We used `r pkrt("foo")` to extract the data.

    Analyses were performed using `r pkrt("bar")`.

    ## References

pakret handles everything for you.

Here’s the markdown output produced by the document above:

    We used the ‘foo’ package version 1.0.0 (Fastandfurius, Clausus, and
    Lastopus 2020) to extract the data.

    Analyses were performed using the ‘bar’ package version 0.2.0
    (Itisalapsus 2024).

    ## References

    Fastandfurius, Caius, Numerius Clausus, and Marcus Lastopus. 2020.
    *<span class="nocase">foo</span>: Alea Jacta Est*.

    Itisalapsus, Julius. 2024. *<span class="nocase">bar</span>: Tempus Edax
    Rerum*.

You can also cite a collection of packages with `pkrt_list()`:

    ---
    bibliography: references.bib
    ---

    ```{r}
    #| include: false
    library(pakret)
    ```

    I used the following packages: `r pkrt_list("foo", "bar")`.

    ## References

<!-- separator -->

    I used the following packages: ‘foo’ v. 1.0.0 (Fastandfurius, Clausus,
    and Lastopus 2020), and ‘bar’ v. 0.2.0 (Itisalapsus 2024).

    ## References

    Fastandfurius, Caius, Numerius Clausus, and Marcus Lastopus. 2020.
    *<span class="nocase">foo</span>: Alea Jacta Est*.

    Itisalapsus, Julius. 2024. *<span class="nocase">bar</span>: Tempus Edax
    Rerum*.

Unhappy with the default templates? pakret lets you define your own:

    ---
    bibliography: references.bib
    ---

    ```{r}
    #| include: false

    library(pakret)
    pkrt_set(pkg = "the R package *:pkg* [v. :ver, :ref]")
    ```

    We used `r pkrt("foo")` to analyse the data.

    ## References

<!-- separator -->

    We used the R package *foo* (v. 1.0.0, Fastandfurius, Clausus, and
    Lastopus 2020) to analyse the data.

    ## References

    Fastandfurius, Caius, Numerius Clausus, and Marcus Lastopus. 2020.
    *<span class="nocase">foo</span>: Alea Jacta Est*.

Note that by default pakret writes new references into the first `.bib`
file specified in the bibliography list. You can change which `.bib`
file to save references to using `pkrt_set()`.

dedent <- function(x) {
  indentation <- sub("(?s)\\S*\\R(\\s*).+", "\\1", x, perl = TRUE)
  x <- gsub(paste0("(?m)^", indentation), "", x, perl = TRUE)
  trimws(x)
}

render <- function(...) {
  rmarkdown::render(..., output_format = "md_document", quiet = TRUE)
}

local_rmd <- function(lines = "", ...) {
  withr::local_tempfile(lines = lines, fileext = ".Rmd", ...)
}

local_bib <- function(lines, ...) {
  dir <- withr::local_tempfile(lines = lines, fileext = ".bib", ...)
  basename(dir)
}

local_bibs <- function(settings, ...) {
  if (settings$n == 1L) {
    return(local_bib(settings$lines, ...))
  }
  lapply(seq_len(settings$n), function(i) {
    lines <- if (i == settings$write_to) settings$lines else ""
    local_bib(lines, pattern = paste0("file_", i), ...)
  })
}

insert_bibs <- function(lines, bibs) {
  if (length(bibs) > 1L) {
    bibs <- sprintf("[%s]", paste(bibs, collapse = ", "))
  }
  sprintf(lines, bibs)
}

local_set <- function(lines = "", n = 1L, write_to = n) {
  list(lines = lines, n = n, write_to = write_to)
}

local_files <- function(rmd_lines, bib = local_set(), env = parent.frame()) {
  dir <- withr::local_tempdir(.local_envir = env)
  if (!is.null(bib)) {
    bibs <- local_bibs(bib, tmpdir = dir, .local_envir = env)
    rmd_lines <- insert_bibs(rmd_lines, bibs)
  }
  rmd <- local_rmd(rmd_lines, tmpdir = dir, .local_envir = env)
  with_pakret_error(callr::r(render, list(input = rmd)))
  invisible(dir)
}

with_pakret_error <- function(expr) {
  tryCatch(expr, error = function(e) stop(e$parent))
}

read_local_file <- function(dir, target = "md") {
  items <- strsplit(target, ".", fixed = TRUE)[[1]]
  if (length(items) == 1L) {
    items <- c("", items)
  }
  pattern <- do.call(sprintf, c("^%s.+\\.%s$", as.list(items)))
  file <- list.files(dir, pattern = pattern, full.names = TRUE)
  readr::read_file(file)
}

local_pkg <- function(Package, ..., bib_entries = NULL, env = parent.frame()) {
  dir <- withr::local_tempdir(.local_envir = env)
  withr::local_libpaths(dir, action = "prefix", .local_envir = env)
  pkg_path <- file.path(dir, Package)
  create_package(pkg_path, Package, ...)
  if (!is.null(bib_entries)) {
    lines <- make_bib_entries(bib_entries)
    add_bib_entries(pkg_path, lines)
  }
  load_pkg(pkg_path, env)
  invisible(pkg_path)
}

create_package <- function(path, Package, ...) {
  usethis::ui_silence(
    usethis::create_package(
      path = path,
      fields = list(Type = "Package", Package = Package, ...),
      rstudio = FALSE,
      open = FALSE
    )
  )
}

add_bib_entries <- function(dir, lines) {
  path <- file.path(dir, "inst", "CITATION")
  dir.create(dirname(path))
  readr::write_file(lines, path)
}

make_bib_entries <- function(types) {
  bib <- 'bibentry("%s", title = "title", author = "authors", year = "year",%s)'
  entries <- lapply(tolower(types), function(type) {
    sprintf(bib, type, switch_bib_field(type))
  })
  collapse(entries)
}

switch_bib_field <- function(x) {
  switch(x,
    article = bib_field("journal"),
    book = bib_field("publisher"),
    ""
  )
}

bib_field <- function(name) {
  sprintf('%s = "%s"', name, name)
}

load_pkg <- function(path, env) {
  withr::defer(pkgload::unload(basename(path), quiet = TRUE), envir = env)
  pkgload::load_all(path, export_all = FALSE, quiet = TRUE)
}

load_foo <- function(..., env = parent.frame()) {
  local_pkg(
    Package = "foo",
    Title = "Alea Jacta Est",
    `Authors@R` = c(
      utils::person("Caius", "Fastandfurius", role = "aut"),
      utils::person("Numerius", "Clausus", role = "aut"),
      utils::person("Marcus", "Lastopus", role = "aut")
    ),
    Version = "1.0.0",
    Date = "2020-01-01",
    ...,
    env = env
  )
}

load_bar <- function(..., env = parent.frame()) {
  local_pkg(
    Package = "bar",
    Title = "Tempus Edax Rerum",
    `Authors@R` = utils::person("Julius", "Itisalapsus", role = "aut"),
    Version = "0.2.0",
    Date = "2024-01-01",
    ...,
    env = env
  )
}

test_that("pkrt_list() makes a list of citations", {
  load_foo()
  load_bar()
  citations <- pkrt_list("foo", "bar")

  expect_snapshot(citations)
  expect_snapshot(str(citations))
})

test_that("citation lists can be turned into data frames", {
  load_foo()
  load_bar()
  local_pkg("zzz", Version = "0.1.0")
  citations <- pkrt_list("zzz", "bar", "foo")

  expect_equal(
    as.data.frame(citations),
    data.frame(
      Package = c("bar", "foo", "zzz"),
      Version = c("0.2.0", "1.0.0", "0.1.0"),
      Reference = c("@bar", "@foo", "@zzz")
    )
  )
})

test_that("pkrt_list() removes duplicate and base packages", {
  load_foo()
  citations <- pkrt_list("foo", "foo", "base")
  expect_equal(names(citations), "foo")
})

test_that("pkrt_list() correctly enumerates packages in inline chunks", {
  template <- dedent("
    ---
    bibliography: %s
    ---
    ```{r}
    #| echo: false
    library(pakret)
    pakret:::load_foo()
    pakret:::load_bar()
    ```
    `r pkrt_list('foo', 'bar')`
  ")
  dir <- local_files(template)
  res <- read_local_file(dir)
  expect_snapshot(cat(res))
})

# errors

test_that("pkrt_list() gives meaningful error messages", {
  expect_snapshot(pkrt_list(1), error = TRUE)
})

test_that("pkrt() cites and references packages", {
  dir <- local_files(make_template(lines = "`r pkrt('foo')`"))
  res <- read_local_file(dir)
  expect_snapshot(cat(res))
})

test_that("bib entries are properly appended to bib files", {
  template <- make_template(lines = "`r pkrt('foo')` `r pkrt('bar')`")
  dir <- local_files(template)
  res <- read_local_file(dir, target = "bib")
  expect_snapshot(cat(res))

  load_bar()
  template <- make_template(lines = "`r pkrt('foo')`")
  dir <- local_files(template, bib = local_set(lines = ref_get("bar")))
  res <- read_local_file(dir, target = "bib")
  expect_snapshot(cat(res))
})

test_that("multi-bib entries are properly handled", {
  template <- dedent("
    ---
    bibliography: %s
    ---
    ```{r}
    library(pakret)
    pakret:::load_foo(bib_entries = c('Book', 'Manual'))
    pakret:::load_bar(bib_entries = c('article', 'book'))
    pakret:::local_pkg('baz', bib_entries = c('Misc', 'Article'))
    ```
    `r pkrt('foo')`
    `r pkrt('bar')`
    `r pkrt('baz')`
  ")
  dir <- local_files(template)
  res <- read_local_file(dir, target = "bib")

  expect_match(res, "@Manual\\{foo,")
  expect_match(res, "@Book\\{bar,")
  expect_match(res, "@Misc\\{baz,")
  expect_length(extract(res, "(?m)^@"), 3L)
})

test_that("citing the same package again doesn't add a new bib entry", {
  dir <- local_files(make_template(lines = strrep("`r pkrt('foo')`", 2L)))
  res <- read_local_file(dir, target = "bib")
  expect_length(extract(res, "(?m)^@"), 1L)
})

test_that("citing no packages doesn't modify bib files", {
  load_foo()
  citation <- ref_get("foo")
  template <- make_template(lines = "")
  dir <- local_files(template, bib = local_set(lines = citation))
  res <- read_local_file(dir, target = "bib")
  expect_equal(res, paste0(citation, "\n"))
})

test_that("pkrt() cites R", {
  pattern <- "R version [\\d.]+ \\[@base\\]"
  expect_match(pkrt("R"), regexp = pattern, perl = TRUE)
  expect_match(pkrt("base"), regexp = pattern, perl = TRUE)
})

test_that("pakret handles references that have a premade key (#18)", {
  template <- dedent("
    ---
    bibliography: %s
    ---
    ```{r}
    library(pakret)
    path <- pakret:::local_pkg('baz')
    pakret:::add_bib_entries(
      path,
      \"bibentry('manual', key = 'abc', title = 'title')\"
    )
    ```
    `r pkrt('baz')`
  ")
  dir <- local_files(template)
  res <- read_local_file(dir, target = "bib")

  expect_match(res, "@Manual\\{baz,")
})

test_that("pakret works with modified frame stacks (#30)", {
  template <- dedent("
    ---
    bibliography: %s
    ---
    ```{r}
    (function() library(pakret))()
    pakret:::load_foo()
    ```
    `r pkrt('foo')`
  ")
  dir <- local_files(template)
  res <- read_local_file(dir, target = "bib")

  expect_match(res, "@Manual\\{foo,")
})

test_that("pakret preserves the case of package and single-letter names", {
  template <- dedent("
    ---
    bibliography: %s
    ---
    ```{r}
    library(pakret)
    pakret:::local_pkg('baz', Title = 'A Simple R Test With a Protected {B}')
    ```
    `r pkrt('baz')`
  ")
  dir <- local_files(template)
  res <- read_local_file(dir, target = "bib")

  expect_snapshot(cat(res))
})

test_that("pakret creates bib files if needed", {
  template <- dedent("
    ---
    bibliography: pkrt.bib
    ---
    ```{r}
    library(pakret)
    pakret:::load_foo()
    ```
    `r pkrt('foo')`
  ")
  dir <- local_files(template, bib = NULL)
  res <- read_local_file(dir, target = "bib")

  expect_match(res, "@Manual\\{foo,")
})

test_that("pkrt() returns an object of class `AsIs` (#51)", {
  load_foo()
  expect_s3_class(pkrt("foo"), "AsIs")
})

# errors

test_that("pkrt() gives meaningful error messages", {
  expect_snapshot({
    (expect_error(
      pkrt(1)
    ))
    (expect_error(
      pkrt("a")
    ))
  })
})

test_that("custom templates work", {
  load_foo()
  local_settings(pkg = ":ref :ver :pkg")
  expect_equal(pkrt("foo"), "@foo 1.0.0 foo", ignore_attr = "class")

  local_settings(pkg = ":pkg :ref")
  expect_equal(pkrt("foo"), "foo @foo", ignore_attr = "class")
})

test_that("`NULL` resets settings to their default value", {
  load_foo()
  pkrt_set(pkg = ":ref :ver :pkg")
  pkrt_set(pkg = NULL)
  expect_equal(
    pkrt("foo"),
    "the 'foo' package version 1.0.0 [@foo]",
    ignore_attr = "class"
  )
})

test_that("writing bib entries in the desired file works", {
  template <- make_template(lines = dedent("
    ```{r}
    pkrt_set(bib = 2L)
    pkrt('foo')
    ```
  "))
  load_bar()
  dir <- local_files(template, bib = local_set(
    # the pre-written ref is to ensure that pkrt_set() resets bib metadata (#22)
    lines = ref_get("bar"),
    n = 2L
  ))

  res <- read_local_file(dir, target = "file_1.bib")
  expect_match(res, "^\\R$", perl = TRUE)

  res <- read_local_file(dir, target = "file_2.bib")
  expect_match(res, "@Manual\\{bar,")
  expect_match(res, "@Manual\\{foo,")
  expect_length(extract(res, "(?m)^@"), 2L)
})

test_that("writing bib entries in multiple file works", {
  template <- make_template(lines = dedent("
    ```{r}
    pkrt_set(bib = 2L)
    pkrt('bar')

    pkrt_set(bib = NULL)
    pkrt('foo')
    ```
  "))
  dir <- local_files(template, bib = local_set(n = 2L))

  res <- read_local_file(dir, target = "file_1.bib")
  expect_match(res, "^@Manual\\{foo,")
  expect_length(extract(res, "(?m)^@"), 1L)

  res <- read_local_file(dir, target = "file_2.bib")
  expect_match(res, "^@Manual\\{bar,")
  expect_length(extract(res, "(?m)^@"), 1L)
})

test_that("updating `str` settings works", {
  local_settings(sep_last = " or ")
  expect_equal(get("sep_last"), " or ")
})

# errors

test_that("pkrt_set() gives meaningful error messages", {
  expect_snapshot({
    (expect_error(
      pkrt_set("a")
    ))
    (expect_error(
      pkrt_set(pkg = list("a"))
    ))
    (expect_error(
      pkrt_set(pkg = rep("a", 2L))
    ))
    (expect_error(
      pkrt_set(foo = 1)
    ))
    (expect_error(
      pkrt_set(pkg = 1)
    ))
    (expect_error(
      pkrt_set(pkg = ":pkg :ver")
    ))
    (expect_error(
      pkrt_set(pkg = ":pkg :ver :ref :blah")
    ))
    (expect_error(
      pkrt_set(pkg = ":pkg :ver :ver :ref")
    ))
  })

  expect_snapshot(
    local_files(make_template(lines = "`r pkrt_set(bib = TRUE)`")),
    error = TRUE
  )

  expect_snapshot(
    local_files(make_template(lines = "`r pkrt_set(bib = 'test')`")),
    error = TRUE
  )

  expect_snapshot(
    local_files(make_template(lines = "`r pkrt_set(bib = 2)`")),
    error = TRUE
  )
})

test_that("pakret initialisation gives meaningful error messages", {
  expect_snapshot(
    local_files(make_template(meta = "title: no bibs"), bib = NULL),
    error = TRUE
  )

  expect_snapshot(
    local_files(make_template(meta = "bibliography: foo.md"), bib = NULL),
    error = TRUE
  )
})

.onLoad <- function(...) {
  do.call(set, .__settings__)
  if (is_rendering_context()) {
    knitr::knit_hooks$set(after.knit = bib_write)
    bibs <- rmarkdown::metadata$bibliography
    set(render = TRUE, bibliography = bibs, eol = eol())
    bib_init()
  }
}

#' @title Cite R or an R package
#' @description Creates a preformatted citation for R or an R package. This
#'   function is normally used within an R Markdown or Quarto document, where
#'   `pkrt()` automatically references the cited package to the first (by
#'   default) `.bib` file specified in the YAML header if no reference for the
#'   package already exists.
#' @param pkg Name of the package to cite. You can use `"R"` as an alias for the
#'   base package to cite R.
#' @returns A character string with S3 class `AsIs`.
#' @examples
#' pkrt("pakret")
#'
#' pkrt("R")
#' @export
pkrt <- function(pkg) {
  check_string(pkg)
  cite(as_pkg(pkg))
}

#' @title Cite a collection of R packages
#' @description Creates a list of package citations that can be converted into a
#'   character string or data frame. This function is normally used within an R
#'   Markdown or Quarto document, where `pkrt_list()` automatically references
#'   the cited packages in the first (by default) `.bib` file specified in the
#'   YAML header if no reference for the packages already exists.
#' @param ... Character vectors, separated by commas, of packages to cite.
#' @details
#' This function automatically discards duplicate and base packages. You can use
#' `pkrt_list()` in combination with [`renv::dependencies()`] to cite all the
#' packages used in a project or directory.
#' @returns A list of package citations with S3 class `pkrt_list`.
#' @examples
#' # Create a list of citations
#' citations <- pkrt_list("pakret", "readr", "knitr")
#'
#' # You can then turn the citations into a character string
#' # Note that this is done automatically in inline chunks
#' paste(citations, collapse = ", ")
#'
#' # Or a data frame
#' as.data.frame(citations)
#' @export
pkrt_list <- function(...) {
  pkgs <- unique(c(...))
  check_character(pkgs, arg = "...")
  pkgs <- drop_base(pkgs)
  itemize_citations(pkgs)
}

drop_base <- function(x) {
  x[!x %in% base_pkgs()]
}

base_pkgs <- function() {
  if (getRversion() >= "4.4.0") {
    return(asNamespace("tools")$standard_package_names()[["base"]])
  }
  c(
    "base", "compiler", "datasets", "graphics", "grDevices", "grid", "methods",
    "parallel", "splines", "stats", "stats4", "tcltk", "tools", "utils"
  )
}

itemize_citations <- function(pkgs) {
  names(pkgs) <- pkgs
  citations <- lapply(pkgs, function(pkg) {
    citation <- cite(pkg, template = "pkg_list")
    attributes(citation) <- pkg_details(pkg)
    citation
  })
  add_class(citations, "pkrt_list")
}

#' @export
as.data.frame.pkrt_list <- function(x, ...) {
  x <- sort(x)
  x <- do.call(rbind.data.frame, lapply(x, attributes))
  row.names(x) <- NULL
  names(x) <- c("Package", "Version", "Reference")
  x
}

sort.pkrt_list <- function(x, ...) {
  pkgs <- vapply(x, function(.x) attr(.x, "pkg"), character(1L))
  x[sort(pkgs)]
}

#' @export
print.pkrt_list <- function(x, ...) {
  x <- lapply(x, unstructure)
  NextMethod()
}

unstructure <- function(x) {
  attributes(x) <- NULL
  x
}

#' @export
knit_print.pkrt_list <- function(x, ..., inline = FALSE) {
  if (inline) {
    return(enumerate(x))
  }
  NextMethod()
}

enumerate <- function(x) {
  n <- length(x)
  if (n == 1L) {
    return(x)
  }
  lhs <- paste(x[-n], collapse = get("sep"))
  paste0(lhs, get("sep_last"), x[n])
}

add_class <- function(x, cls) {
  class(x) <- cls
  x
}

.__settings__ <- list(
  bib = add_class(1L, "bib"),
  pkg = add_class("the ':pkg' package version :ver [:ref]", "template"),
  pkg_list = add_class("':pkg' v. :ver [:ref]", "template"),
  r = add_class("R version :ver [:ref]", "template"),
  sep = add_class(", ", "str"),
  sep_last = add_class(", and ", "str")
)

.__pakret__ <- new.env(parent = emptyenv())

set <- function(..., .add = FALSE) {
  items <- eval(substitute(alist(...)))
  for (key in names(items)) {
    .__pakret__[[key]] <- eval_set(items, key, .add)
  }
}

eval_set <- function(x, key, add, envir = parent.frame(2L)) {
  x <- eval(x[[key]], envir = envir)
  if (is_string(x) && has_placeholder(x)) {
    x <- list(str = as_sprintf(x), vars = vars(x))
  }
  if (add) {
    x <- c(get(key), x)
  }
  x
}

get <- function(x) {
  .__pakret__[[x]]
}

.regex <- list(
  placeholder = "\\B:[a-z]+\\b"
)

eol <- function() {
  if (.Platform$OS.type == "unix") "\n" else "\r\n"
}

collapse <- function(x) {
  paste(x, collapse = strrep(eol(), 2L))
}

bib_name <- function(x) {
  sub("(?i)\\.bib$", "", basename(x))
}

extract <- function(x, pattern) {
  locs <- gregexpr(pattern, x, perl = TRUE)
  regmatches(x, locs)[[1]]
}

as_pkg <- function(x) {
  if (is_r(x)) {
    return(as_r())
  }
  add_class(x, "pkg")
}

as_r <- function() {
  add_class("base", cls = "r")
}

bib_init <- function() {
  check_bibliography()
  bib_set()
}

bib_set <- function() {
  set(
    refs = list(),
    append = FALSE,
    file = bib_fetch(),
    keys = extract_keys()
  )
}

bib_fetch <- function() {
  bibs <- get("bibliography")
  names(bibs) <- bib_name(bibs)
  file <- bibs[[get("bib")]]
  check_bib(file, arg = file)
  resolve_path(file)
}

resolve_path <- function(x) {
  dir <- knitr::opts_knit$get("output.dir")
  path <- file.path(dir, x)
  if (!file.exists(path)) {
    file.create(path)
  }
  path
}

extract_keys <- function() {
  bib <- bib_read()
  keys <- extract(bib, "(?mi)^@[a-z]+\\{\\K[^,]+")
  if (is_empty(keys)) {
    return()
  }
  keys
}

bib_read <- function() {
  out <- readr::read_file(get("file"))
  if (!is_blank(out)) {
    set(append = TRUE)
  }
  out
}

bib_write <- function() {
  if (is_empty(get("refs"))) {
    return(invisible())
  }
  lines <- make_lines()
  readr::write_file(lines, get("file"), append = get("append"))
}

make_lines <- function() {
  out <- collapse(get("refs"))
  if (get("append")) {
    out <- paste0(get("eol"), out)
  }
  paste0(out, get("eol"))
}

ref_add <- function(x) {
  if (is_referenced(x)) {
    return()
  }
  set(
    refs = ref_get(x),
    keys = x,
    .add = TRUE
  )
}

ref_get <- function(x) {
  ref <- utils::citation(x)
  ref <- format(ref, style = "bibtex")
  if (length(ref) > 1L) {
    ref <- ref_pick(ref)
  }
  ref_normalize(ref, key = x)
}

ref_pick <- function(x) {
  for (type in c("manual", "book")) {
    if (has_bibtex(x, type)) {
      x <- bibtex_pick(x, type)
      break
    }
  }
  x[[1]]
}

bibtex_pick <- function(x, type) {
  x[bibtex_is(x, type)]
}

ref_normalize <- function(ref, key) {
  ref <- insert_key(ref, key)
  protect_case(ref, key)
}

insert_key <- function(x, key) {
  sub("^@[^{]+\\{\\K[^,]*", key, x, perl = TRUE)
}

protect_case <- function(x, key) {
  x <- strsplit(x, "\n", fixed = TRUE)[[1]]
  title <- grep("title =", x, fixed = TRUE)
  pattern <- sprintf("((?<!: |\\{)\\b[A-Z]\\b|%s(?!\\}))", key)
  x[title] <- gsub(pattern, "{\\1}", x[[title]], perl = TRUE)
  paste(x, collapse = "\n")
}

cite <- function(x, template = class(x)) {
  check_pkg(x)
  if (is_rendering()) {
    ref_add(x)
  }
  cast(template, pkg_details(x))
}

cast <- function(x, items) {
  template <- get(x)
  I(do.call(sprintf, c(template$str, items[template$vars])))
}

as_sprintf <- function(x) {
  gsub(.regex$placeholder, "%s", x, perl = TRUE)
}

vars <- function(x) {
  extract(x, "(?<=\\B:)[a-z]+\\b")
}

pkg_details <- function(pkg) {
  list(
    pkg = pkg,
    ver = get_version(pkg),
    ref = paste0("@", pkg)
  )
}

get_version <- function(x) {
  as.character(utils::packageVersion(x))
}

is_rendering <- function() {
  isTRUE(get("render"))
}

is_rendering_context <- function() {
  is_knitting() && has_metadata() && getOption("pakret.render_mode", TRUE)
}

is_knitting <- function() {
  isTRUE(getOption("knitr.in.progress"))
}

is_empty <- function(x) {
  length(x) == 0L || all(x == "")
}

is_referenced <- function(pkg) {
  pkg %in% get("keys")
}

is_bib <- function(x) {
  n <- nchar(x)
  tolower(substr(x, n - 3L, n)) == ".bib"
}

is_updating_bib <- function(x) {
  is_rendering() && names(x) == "bib" && x != get("bib")
}

is_scalar <- function(x) {
  length(x) == 1L
}

is_string <- function(x) {
  is.character(x) && is_scalar(x)
}

is_blank <- function(x) {
  grepl("^\\s*$", x)
}

is_named <- function(x) {
  nms <- names(x)
  if (is.null(nms) || any(nms == "")) {
    return(FALSE)
  }
  TRUE
}

is_r <- function(x) {
  x %in% c("R", "base")
}

bibtex_is <- function(x, type) {
  tolower(substr(x, 2L, nchar(type) + 1L)) == type
}

has_bibtex <- function(x, type) {
  any(vapply(x, function(.x) bibtex_is(.x, type), logical(1L)))
}

has_metadata <- function() {
  !is_empty(rmarkdown::metadata)
}

has_placeholder <- function(x) {
  grepl(.regex$placeholder, x, perl = TRUE)
}

abort <- function(msg, ...) {
  stop(error(msg, ...), call. = FALSE)
}

error <- function(msg, ...) {
  msg <- paste(msg, collapse = "\n")
  if (...length() == 0L) {
    return(msg)
  }
  sprintf(msg, ...)
}

caller_arg <- function() {
  deparse(substitute(x, env = parent.frame()))
}

check_type <- function(x, asserter, expected, arg) {
  if (asserter(x)) {
    return(invisible())
  }
  abort(paste0("`%s` must be ", expected, "."), arg)
}

check_string <- function(x, arg = caller_arg()) {
  check_type(x, is_string, "a string", arg)
}

check_character <- function(x, arg = caller_arg()) {
  check_type(x, is.character, "a character vector", arg)
}

check_scalar <- function(x, arg = caller_arg()) {
  asserter <- function(x) is.null(x) || is_scalar(x)
  check_type(x, asserter, "a single element vector", arg)
}

check_atomic <- function(x, arg = caller_arg()) {
  asserter <- function(x) is.null(x) || is.atomic(x)
  check_type(x, asserter, "an atomic vector", arg)
}

check_named <- function(x, arg = caller_arg()) {
  if (is_named(x)) {
    return(invisible())
  }
  abort("All elements of `%s` must be named.", arg)
}

check_template <- function(x, arg) {
  check_string(x, arg)
  vars_curr <- vars(x)
  check_duplicated_vars(vars_curr, arg)
  vars_default <- vars(.__settings__[[arg]])
  check_missing_vars(vars_curr, vars_default[vars_default != "ver"], arg)
  check_invalid_vars(vars_curr, vars_default, arg)
}

seek <- function(x, cnd) {
  if (all(!cnd)) {
    return()
  }
  x[[which(cnd)[[1]]]]
}

check_duplicated_vars <- function(x, arg) {
  duplicated <- seek(x, duplicated(x))
  if (is.null(duplicated)) {
    return(invisible())
  }
  abort("Duplicate placeholder `:%s` found in `%s`.", duplicated, arg)
}

check_missing_vars <- function(x, valid, arg) {
  missing <- seek(valid, !valid %in% x)
  if (is.null(missing)) {
    return(invisible())
  }
  abort("`%s` requires the `:%s` placeholder.", arg, missing)
}

check_invalid_vars <- function(x, allowed, arg) {
  not_allowed <- seek(x, !x %in% allowed)
  if (is.null(not_allowed)) {
    return(invisible())
  }
  abort("Invalid placeholder `:%s` found in `%s`.", not_allowed, arg)
}

check_settings <- function(x) {
  x <- names(x)
  invalid <- seek(x, !x %in% names(.__settings__))
  if (is.null(invalid)) {
    return(invisible())
  }
  abort("`%s` isn't a valid setting.", invalid)
}

check_option_bib <- function(x, arg = caller_arg()) {
  asserter <- function(x) is.numeric(x) || is_string(x)
  check_type(x, asserter, "a numeric value or a string", arg)
}

check_bibliography <- function() {
  if (!is.null(get("bibliography"))) {
    return(invisible())
  }
  abort(c(
    "No `.bib` files found.",
    "You must provide a `.bib` file to the `bibliography` YAML key."
  ))
}

check_bib_target <- function(x) {
  check_bib_target_(unclass(x), get("bibliography"))
}

check_bib_target_ <- function(x, bibs) {
  UseMethod("check_bib_target_")
}

check_bib_target_.character <- function(x, bibs) {
  if (x %in% bib_name(bibs)) {
    return(invisible())
  }
  abort("`%s.bib` doesn't exist in the bibliography list.", x)
}

check_bib_target_.numeric <- function(x, bibs) {
  if (x > 0L && x <= length(bibs)) {
    return(invisible())
  }
  abort("`bib` index out of bound.")
}

check_bib <- function(x, arg = caller_arg()) {
  check_type(x, is_bib, "a `.bib` file", arg)
}

check_pkg <- function(pkg) {
  path <- system.file(package = pkg)
  if (!is_empty(path)) {
    return(invisible())
  }
  abort("Package `%s` doesn't exist or isn't installed.", pkg)
}

#' @title Configure pakret's settings
#' @description This function lets you configure pakret's settings, for example,
#'   to customize citation templates or specify which `.bib` file should store
#'   the references.
#' @param ... Key-value pairs, separated by commas, of parameters to set. See
#'   details.
#' @details
#' Valid parameters are:
#' `r make_pkrt_set_details()`
#'
#' New settings only apply to citations that come after `pkrt_set()`. This means
#' you can redefine the same settings multiple times in the same document to
#' alter pakret's behavior for a few specific citations only.
#'
#' Use `NULL` to reset a parameter to its default value.
#' @returns This function is called for its side-effect. It returns no value.
#' @examples
#' pkrt_set(pkg = "*:pkg* :ver :ref")
#' pkrt("pakret")
#'
#' # `NULL` resets parameters to their default value
#' pkrt_set(pkg = NULL)
#' pkrt("pakret")
#' @export
pkrt_set <- function(...) {
  items <- list(...)
  check_named(items, arg = "...")
  check_settings(items)
  for (key in names(items)) {
    update_setting(key, items[[key]])
  }
}

update_setting <- function(key, value) {
  check_atomic(value, arg = key)
  check_scalar(value, arg = key)
  if (is.null(value)) {
    return(reset(key))
  }
  setting <- as_setting(value, key)
  set_option(setting)
}

reset <- function(x) {
  update(.__settings__[x])
}

update <- function(x) {
  if (is_updating_bib(x)) {
    bib_write()
    on.exit(bib_set(), add = TRUE)
  }
  do.call(set, as.list(x))
}

as_setting <- function(x, name) {
  structure(x, names = name, class = class(.__settings__[[name]]))
}

set_option <- function(x) {
  UseMethod("set_option")
}

set_option.template <- function(x) {
  check_template(x, arg = names(x))
  update(x)
}

set_option.str <- function(x) {
  check_string(x, arg = names(x))
  update(x)
}

set_option.bib <- function(x) {
  if (!is_rendering()) {
    return(invisible())
  }
  check_option_bib(x, arg = names(x))
  if (is.character(x)) {
    x[] <- bib_name(x)
  }
  check_bib_target(x)
  update(x)
}

# doc ----

.layout <- "
  * **%s**<br>
    `<%s> = %s`<br>
    %s
"

make_pkrt_set_details <- function() {
  out <- lapply(names(.details), function(key, value = .details[[key]]) {
    default <- unclass(.__settings__[[key]])
    if (!is.list(value)) {
      value <- as.list(value)
    }
    if (is.null(value$type)) {
      value$type <- typeof(default)
    }
    sprintf(dedent(.layout), key, value$type, deparse(default), value[[1]])
  })
  collapse(out)
}

.details <- list(
  bib = list(
    "Name or index of the `.bib` file to save references to.",
    type = "character|numeric"
  ),
  pkg = "Template used to cite a package.",
  pkg_list = "Template used in `pkrt_list()`.",
  r = "Template used to cite R.",
  sep = "Separator used between packages in inline chunks.",
  sep_last = "Separator used between the last two packages in inline chunks."
)

local_settings <- function(..., env = parent.frame()) {
  withr::defer(reset(...names()), envir = env)
  pkrt_set(...)
}

make_template <- function(lines = "", meta = "bibliography: %s") {
  pkgs <- extract_pkgs(lines)
  to_load <- if (!is_empty(pkgs)) to_load(pkgs) else ""
  sprintf(dedent(template), meta, to_load, lines)
}

extract_pkgs <- function(x) {
  unique(extract(x, "pkrt\\([\"']\\K[a-z]+"))
}

to_load <- function(x) {
  paste0("pakret:::load_", x, "()", collapse = "; ")
}

template <- "
  ---
  %s
  ---

  ```{r, include = FALSE}
  library(pakret)
  %s
  ```

  %s

  # References
"

# pkrt() cites and references packages

    Code
      cat(res)
    Output
      the ‘foo’ package version 1.0.0 (Fastandfurius, Clausus, and Lastopus
      2020)
      
      # References
      
      Fastandfurius, Caius, Numerius Clausus, and Marcus Lastopus. 2020.
      *<span class="nocase">foo</span>: Alea Jacta Est*.

# bib entries are properly appended to bib files

    Code
      cat(res)
    Output
      @Manual{foo,
        title = {{foo}: Alea Jacta Est},
        author = {Caius Fastandfurius and Numerius Clausus and Marcus Lastopus},
        year = {2020},
        note = {R package version 1.0.0},
      }
      
      @Manual{bar,
        title = {{bar}: Tempus Edax Rerum},
        author = {Julius Itisalapsus},
        year = {2024},
        note = {R package version 0.2.0},
      }

---

    Code
      cat(res)
    Output
      @Manual{bar,
        title = {{bar}: Tempus Edax Rerum},
        author = {Julius Itisalapsus},
        year = {2024},
        note = {R package version 0.2.0},
      }
      
      @Manual{foo,
        title = {{foo}: Alea Jacta Est},
        author = {Caius Fastandfurius and Numerius Clausus and Marcus Lastopus},
        year = {2020},
        note = {R package version 1.0.0},
      }

# pakret preserves the case of package and single-letter names

    Code
      cat(res)
    Output
      @Manual{baz,
        title = {{baz}: A Simple {R} Test With a Protected {B}},
        author = {First Last},
        note = {R package version 0.0.0.9000},
      }

# pkrt() gives meaningful error messages

    Code
      (expect_error(pkrt(1)))
    Output
      <simpleError: `pkg` must be a string.>
    Code
      (expect_error(pkrt("a")))
    Output
      <simpleError: Package `a` doesn't exist or isn't installed.>

# pkrt_list() makes a list of citations

    Code
      citations
    Output
      $foo
      [1] "'foo' v. 1.0.0 [@foo]"
      
      $bar
      [1] "'bar' v. 0.2.0 [@bar]"
      

---

    Code
      str(citations)
    Output
      List of 2
       $ foo: chr "'foo' v. 1.0.0 [@foo]"
        ..- attr(*, "pkg")= chr "foo"
        ..- attr(*, "ver")= chr "1.0.0"
        ..- attr(*, "ref")= chr "@foo"
       $ bar: chr "'bar' v. 0.2.0 [@bar]"
        ..- attr(*, "pkg")= chr "bar"
        ..- attr(*, "ver")= chr "0.2.0"
        ..- attr(*, "ref")= chr "@bar"
       - attr(*, "class")= chr "pkrt_list"

# pkrt_list() correctly enumerates packages in inline chunks

    Code
      cat(res)
    Output
      ‘foo’ v. 1.0.0 (Fastandfurius, Clausus, and Lastopus 2020), and ‘bar’ v.
      0.2.0 (Itisalapsus 2024)
      
      Fastandfurius, Caius, Numerius Clausus, and Marcus Lastopus. 2020.
      *<span class="nocase">foo</span>: Alea Jacta Est*.
      
      Itisalapsus, Julius. 2024. *<span class="nocase">bar</span>: Tempus Edax
      Rerum*.

# pkrt_list() gives meaningful error messages

    Code
      pkrt_list(1)
    Condition
      Error:
      ! `...` must be a character vector.

# pkrt_set() gives meaningful error messages

    Code
      (expect_error(pkrt_set("a")))
    Output
      <simpleError: All elements of `...` must be named.>
    Code
      (expect_error(pkrt_set(pkg = list("a"))))
    Output
      <simpleError: `pkg` must be an atomic vector.>
    Code
      (expect_error(pkrt_set(pkg = rep("a", 2L))))
    Output
      <simpleError: `pkg` must be a single element vector.>
    Code
      (expect_error(pkrt_set(foo = 1)))
    Output
      <simpleError: `foo` isn't a valid setting.>
    Code
      (expect_error(pkrt_set(pkg = 1)))
    Output
      <simpleError: `pkg` must be a string.>
    Code
      (expect_error(pkrt_set(pkg = ":pkg :ver")))
    Output
      <simpleError: `pkg` requires the `:ref` placeholder.>
    Code
      (expect_error(pkrt_set(pkg = ":pkg :ver :ref :blah")))
    Output
      <simpleError: Invalid placeholder `:blah` found in `pkg`.>
    Code
      (expect_error(pkrt_set(pkg = ":pkg :ver :ver :ref")))
    Output
      <simpleError: Duplicate placeholder `:ver` found in `pkg`.>

---

    Code
      local_files(make_template(lines = "`r pkrt_set(bib = TRUE)`"))
    Condition
      Error:
      ! `bib` must be a numeric value or a string.

---

    Code
      local_files(make_template(lines = "`r pkrt_set(bib = 'test')`"))
    Condition
      Error:
      ! `test.bib` doesn't exist in the bibliography list.

---

    Code
      local_files(make_template(lines = "`r pkrt_set(bib = 2)`"))
    Condition
      Error:
      ! `bib` index out of bound.

# pakret initialisation gives meaningful error messages

    Code
      local_files(make_template(meta = "title: no bibs"), bib = NULL)
    Condition
      Error:
      ! package or namespace load failed for 'pakret':
       .onLoad failed in loadNamespace() for 'pakret', details:
        call: NULL
        error: No `.bib` files found.
      You must provide a `.bib` file to the `bibliography` YAML key.

---

    Code
      local_files(make_template(meta = "bibliography: foo.md"), bib = NULL)
    Condition
      Error:
      ! package or namespace load failed for 'pakret':
       .onLoad failed in loadNamespace() for 'pakret', details:
        call: NULL
        error: `foo.md` must be a `.bib` file.

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/pkrt-set.R
\name{pkrt_set}
\alias{pkrt_set}
\title{Configure pakret's settings}
\usage{
pkrt_set(...)
}
\arguments{
\item{...}{Key-value pairs, separated by commas, of parameters to set. See
details.}
}
\value{
This function is called for its side-effect. It returns no value.
}
\description{
This function lets you configure pakret's settings, for example,
to customize citation templates or specify which \code{.bib} file should store
the references.
}
\details{
Valid parameters are:
\itemize{
\item \strong{bib}\if{html}{\out{<br>}}
\verb{<character|numeric> = 1L}\if{html}{\out{<br>}}
Name or index of the \code{.bib} file to save references to.
\item \strong{pkg}\if{html}{\out{<br>}}
\verb{<character> = "the ':pkg' package version :ver [:ref]"}\if{html}{\out{<br>}}
Template used to cite a package.
\item \strong{pkg_list}\if{html}{\out{<br>}}
\verb{<character> = "':pkg' v. :ver [:ref]"}\if{html}{\out{<br>}}
Template used in \code{pkrt_list()}.
\item \strong{r}\if{html}{\out{<br>}}
\verb{<character> = "R version :ver [:ref]"}\if{html}{\out{<br>}}
Template used to cite R.
\item \strong{sep}\if{html}{\out{<br>}}
\verb{<character> = ", "}\if{html}{\out{<br>}}
Separator used between packages in inline chunks.
\item \strong{sep_last}\if{html}{\out{<br>}}
\verb{<character> = ", and "}\if{html}{\out{<br>}}
Separator used between the last two packages in inline chunks.
}

New settings only apply to citations that come after \code{pkrt_set()}. This means
you can redefine the same settings multiple times in the same document to
alter pakret's behavior for a few specific citations only.

Use \code{NULL} to reset a parameter to its default value.
}
\examples{
pkrt_set(pkg = "*:pkg* :ver :ref")
pkrt("pakret")

# `NULL` resets parameters to their default value
pkrt_set(pkg = NULL)
pkrt("pakret")
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/pkrt-list.R
\name{pkrt_list}
\alias{pkrt_list}
\title{Cite a collection of R packages}
\usage{
pkrt_list(...)
}
\arguments{
\item{...}{Character vectors, separated by commas, of packages to cite.}
}
\value{
A list of package citations with S3 class \code{pkrt_list}.
}
\description{
Creates a list of package citations that can be converted into a
character string or data frame. This function is normally used within an R
Markdown or Quarto document, where \code{pkrt_list()} automatically references
the cited packages in the first (by default) \code{.bib} file specified in the
YAML header if no reference for the packages already exists.
}
\details{
This function automatically discards duplicate and base packages. You can use
\code{pkrt_list()} in combination with \code{\link[renv:dependencies]{renv::dependencies()}} to cite all the
packages used in a project or directory.
}
\examples{
# Create a list of citations
citations <- pkrt_list("pakret", "readr", "knitr")

# You can then turn the citations into a character string
# Note that this is done automatically in inline chunks
paste(citations, collapse = ", ")

# Or a data frame
as.data.frame(citations)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/pakret-package.R
\docType{package}
\name{pakret-package}
\alias{pakret}
\alias{pakret-package}
\title{pakret: Cite 'R' Packages on the Fly in 'R Markdown' and 'Quarto'}
\description{
References and cites 'R' and 'R' packages on the fly in 'R Markdown' and 'Quarto'. 'pakret' provides a minimalist API that generates preformatted citations for 'R' and 'R' packages, and adds their references to a '.bib' file directly from within your document.
}
\seealso{
Useful links:
\itemize{
  \item \url{https://arnaudgallou.github.io/pakret/}
  \item \url{https://github.com/arnaudgallou/pakret}
  \item Report bugs at \url{https://github.com/arnaudgallou/pakret/issues}
}

}
\author{
\strong{Maintainer}: Arnaud Gallou \email{arangacas@gmail.com} (\href{https://orcid.org/0000-0002-1002-4247}{ORCID}) [copyright holder]

}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/pkrt.R
\name{pkrt}
\alias{pkrt}
\title{Cite R or an R package}
\usage{
pkrt(pkg)
}
\arguments{
\item{pkg}{Name of the package to cite. You can use \code{"R"} as an alias for the
base package to cite R.}
}
\value{
A character string with S3 class \code{AsIs}.
}
\description{
Creates a preformatted citation for R or an R package. This
function is normally used within an R Markdown or Quarto document, where
\code{pkrt()} automatically references the cited package to the first (by
default) \code{.bib} file specified in the YAML header if no reference for the
package already exists.
}
\examples{
pkrt("pakret")

pkrt("R")
}
